Public Class Form1

    Private Const g_PrinterIsReady As Boolean = True

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim cust As New Customer("rod", "Stephens")
        cust.PrintInvoices()
        cust.Orders.Add(New Order())
        cust.PrintInvoices()
    End Sub

    Public Class Order
        Private m_BilledOnDate As Date = Nothing
        Public Property BilledOnDate() As Date
            Get
                Return m_BilledOnDate
            End Get
            Set(ByVal value As Date)
                m_BilledOnDate = value
            End Set
        End Property
    End Class

    Public Class Customer
        ' Class Invariant: FirstName and LastName must be non-blank.
        ' Ensure this in constructors and property procedures.
        Public Sub New(ByVal first_name As String, ByVal last_name As String)
            FirstName = first_name
            LastName = last_name
        End Sub

        Private m_FirstName As String = ""
        Public Property FirstName() As String
            Get
                Return m_FirstName
            End Get
            Set(ByVal value As String)
                ' Invariant: FirstName must be non-blank.
                value = value.Trim()
                Debug.Assert(value.Length > 0, "FirstName value must be non-blank")

                m_FirstName = value
            End Set
        End Property

        Private m_LastName As String = ""
        Public Property LastName() As String
            Get
                Return m_LastName
            End Get
            Set(ByVal value As String)
                ' Invariant: LastName must be non-blank.
                value = value.Trim()
                Debug.Assert(value.Length > 0, "LastName value must be non-blank")

                m_LastName = value
            End Set
        End Property

        ' A collection of Order objects.
        Public Orders As New Collection

        ' Print an invoice for unbilled Orders.
        Public Sub PrintInvoices()
            ' Precondition: There must be unbilled Orders.
#If DEBUG Then
            Dim has_unbilled_order As Boolean = False
            For Each test_order As Order In Orders
                If (test_order.BilledOnDate = Nothing) Then
                    has_unbilled_order = True
                    Exit For
                End If
            Next test_order
            Debug.Assert(has_unbilled_order, _
                "Customer " & FirstName & " " & LastName & _
                " has no unbilled Orders before PrintInvoices")
#End If

            ' Assertion: The printer must be ready.
            Debug.Assert(g_PrinterIsReady, _
                "The printer is not ready in subroutine PrintInvoices")

            ' Generate and print the invoices.
            ' ...

            ' Postcondition: All Orders have been billed.
#If DEBUG Then
            For Each test_order As Order In Orders
                Debug.Assert(Not (test_order.BilledOnDate = Nothing), _
                    "Customer " & FirstName & " " & LastName & _
                    " has unbilled Orders after PrintInvoices")
            Next test_order
#End If
        End Sub
    End Class

    Public Class Customer2
        ' Class Invariant: FirstName and LastName must be non-blank.
        ' Ensure this in constructors and property procedures.
        Public Sub New(ByVal first_name As String, ByVal last_name As String)
            FirstName = first_name
            LastName = last_name
        End Sub

        Private m_FirstName As String = ""
        Public Property FirstName() As String
            Get
                Return m_FirstName
            End Get
            Set(ByVal value As String)
                ' Invariant: FirstName must be non-blank.
                value = value.Trim()
                Debug.Assert(value.Length > 0, "FirstName value must be non-blank")

                m_FirstName = value
            End Set
        End Property

        Private m_LastName As String = ""
        Public Property LastName() As String
            Get
                Return m_LastName
            End Get
            Set(ByVal value As String)
                ' Invariant: LastName must be non-blank.
                value = value.Trim()
                Debug.Assert(value.Length > 0, "LastName value must be non-blank")

                m_LastName = value
            End Set
        End Property

        ' A collection of Order objects.
        Public Orders As New Collection

        ' Print an invoice for unbilled Orders.
        Public Sub PrintInvoices()
            ' Precondition: There must be unbilled Orders.
#If DEBUG Then
            Dim has_unbilled_order As Boolean = False
            For Each test_order As Order In Orders
                If (test_order.BilledOnDate = Nothing) Then
                    has_unbilled_order = True
                    Exit For
                End If
            Next test_order
            Debug.Assert(has_unbilled_order, _
                "Customer " & FirstName & " " & LastName & _
                " has no unbilled Orders before PrintInvoices")
#End If
            Try
                DoPrintInvoices()
            Catch ex As Exception
                ' Rethrow the exception.
                Throw ex
            Finally
                ' Postcondition: All Orders have been billed.
#If DEBUG Then
                For Each test_order As Order In Orders
                    Debug.Assert(Not (test_order.BilledOnDate = Nothing), _
                        "Customer " & FirstName & " " & LastName & _
                        " has unbilled Orders after PrintInvoices")
                Next test_order
#End If
            End Try
        End Sub

        Private Sub DoPrintInvoices()
            ' Assertion: The printer must be ready.
            Debug.Assert(g_PrinterIsReady, _
                "The printer is not ready in subroutine PrintInvoices")

            ' Generate and print the invoices.
            ' ...
        End Sub
    End Class
End Class
