Imports System.CodeDom.Compiler
Imports System.Text
Imports System.Reflection

Public Class Form1
    Private Sub btnEvaluate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEvaluate.Click
        lblResult.Text = ""
        lblTime.Text = ""
        lblTrialsPerSec.Text = ""
        Application.DoEvents()

        ' Compose the code.
        Dim vb_code As String = _
            "Imports System" & vbCrLf & _
            "Imports System.Math" & vbCrLf & _
            "Imports System.Windows.Forms" & vbCrLf & vbCrLf & _
            "Namespace MainNamespace" & vbCrLf & _
            "  Class MainClass" & vbCrLf & _
            "    Public Function Main(ByVal A as Double, ByVal B as Double, ByVal C as Double, ByVal D as Double, ByVal E as Double) As Object" & vbCrLf & _
            "        Return " & txtExpr.Text & vbCrLf & _
            "    End Function" & vbCrLf & _
            "  End Class" & vbCrLf & _
            "End Namespace"

        ' Prepare the compiler parameters.
        ' Add any needed references.
        Dim compiler_params As CompilerParameters = New CompilerParameters
        compiler_params.ReferencedAssemblies.Add("system.dll")

        ' Generate a library in memory.
        compiler_params.CompilerOptions = "/t:library"
        compiler_params.GenerateInMemory = True

        ' Compile the code.
        Debug.WriteLine(vb_code)
        Dim code_provider As VBCodeProvider = New VBCodeProvider
        Dim compiler_results As CompilerResults = _
            code_provider.CompileAssemblyFromSource(compiler_params, vb_code)
        code_provider.Dispose()

        ' Check for errors.
        ' CompilerErrors = compiler_results.Errors
        If compiler_results.Errors.Count > 0 Then
            ' There were errors.
            Dim txt As String = "Compiler error:" & vbCrLf & vbCrLf
            For Each compiler_error As CompilerError In compiler_results.Errors
                txt &= vbTab & compiler_error.ErrorText & vbCrLf
            Next compiler_error
            MessageBox.Show(txt, _
                "Compiler Error", _
                MessageBoxButtons.OK, _
                MessageBoxIcon.Exclamation)
        Else
            ' There were no errors. Try to execute the code.
            ' Get the assembly.
            Dim the_assembly As System.Reflection.Assembly = _
                compiler_results.CompiledAssembly

            ' Make a MainClass object.
            Dim main_object As Object = _
                the_assembly.CreateInstance("MainNamespace.MainClass")

            ' Get the MainClass's type.
            Dim main_object_type As Type = main_object.GetType

            ' Get the MainClass's Main method.
            Dim run_method_info As MethodInfo
            run_method_info = main_object_type.GetMethod("Main")

            ' Make the parameters array.
            Dim params(0 To 4) As Object

            ' Get the variable values.
            Dim A As Double = Double.Parse(txtValue1.Text)
            Dim B As Double = Double.Parse(txtValue2.Text)
            Dim C As Double = Double.Parse(txtValue3.Text)
            Dim D As Double = Double.Parse(txtValue4.Text)

            ' Evaluate the expression.
            Dim num_trials As Long = Long.Parse(txtNewTrials.Text)
            Dim result As Double
            Dim start_time As Date = Now
            Try
                For i As Double = 1 To num_trials
                    params(0) = A
                    params(1) = B
                    params(2) = C
                    params(3) = D
                    params(4) = i
                    result = CDbl(run_method_info.Invoke(main_object, params))
                Next i
            Catch ex As Exception
                MessageBox.Show(ex.Message)
            End Try
            lblResult.Text = result.ToString("0.000000")
            Application.DoEvents()
            Dim stop_time As Date = Now

            lblResult.Text = result.ToString("0.000000")
            Dim elapsed_time As TimeSpan = stop_time.Subtract(start_time)
            lblTime.Text = elapsed_time.TotalSeconds.ToString("0.000000")
            lblTrialsPerSec.Text = (num_trials / elapsed_time.TotalSeconds).ToString("0")
        End If
    End Sub
End Class
