Imports System.Data.OleDb

Module DbStuff
    ' Execute a non-query command and return a success or failure string.
    Public Function ExecuteNonQuery(ByVal conn As OleDbConnection, ByVal txt As String) As String
        Try
            ' Make and execute the command.
            Dim cmd As New OleDbCommand(txt, conn)
            cmd.ExecuteNonQuery()
            Return "> Ok"
        Catch ex As Exception
            Return "*** Error executing command ***" & vbCrLf & ex.Message
        End Try
    End Function

    ' Execute a query command and return
    ' the results or failure string.
    Public Function ExecuteQuery(ByVal conn As OleDbConnection, ByVal query As String) As String
        Try
            ' Make and execute the command.
            Dim cmd As New OleDbCommand(query, conn)
            Dim reader As OleDbDataReader = cmd.ExecuteReader()

            ' Display the column names.
            Dim row_txt As String = ""
            For c As Integer = 0 To reader.FieldCount - 1
                row_txt &= ", " & reader.GetName(c)
            Next c

            ' Remove the initial ", ".
            Dim txt As String = "-----" & vbCrLf & _
                row_txt.Substring(2) & vbCrLf & "-----" & vbCrLf

            ' Display the results.
            Do While reader.Read()
                row_txt = ""
                For c As Integer = 0 To reader.FieldCount - 1
                    row_txt &= ", " & reader.Item(c).ToString()
                Next c

                ' Remove the initial ", ".
                txt &= row_txt.Substring(2) & vbCrLf
            Loop
            reader.Close()
            Return txt
        Catch ex As Exception
            Return "*** Error executing SELECT statement ***" & vbCrLf & _
                ex.Message
        End Try
    End Function

End Module
