Imports System.Data.OleDb

Public Class Form1
    ' The database connection.
    Private m_Connection As OleDbConnection

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        PrepareConnection()
    End Sub

    ' Prepare the OleDbConnection object for use.
    Private Sub PrepareConnection()
        ' Compose the database path.
        Dim db_path As String = Application.StartupPath
        If db_path.EndsWith("\bin\Debug") OrElse db_path.EndsWith("\bin\Release") Then
            db_path = db_path.Substring(0, db_path.LastIndexOf("\bin"))
        End If
        If Not db_path.EndsWith("\") Then db_path &= "\"
        db_path &= "Users.mdb"

        ' Prepare the connection.
        m_Connection = New OleDbConnection( _
            "Provider=Microsoft.Jet.OLEDB.4.0;" & _
            "Data Source=""" & db_path & """" _
        )
    End Sub

    ' Verify the user name and password.
    Private Sub btnVerify_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnVerify.Click
        ' Compose the query.
        Dim user_name As String = txtUserName.Text
        Dim password As String = txtPassword.Text
        Dim query As String = _
            "SELECT COUNT(*) FROM Users " & _
            "WHERE UserName = '" & user_name & "'" & _
            "  AND Password = '" & password & "'"
        Debug.WriteLine(query)

        ' Execute the query.
        Try
            m_Connection.Open()
            Dim cmd As New OleDbCommand(query, m_Connection)
            Dim result As Integer = CInt(cmd.ExecuteScalar())
            m_Connection.Close()

            If result > 0 Then
                MessageBox.Show("User verified")
            Else
                MessageBox.Show("Invalid user")
            End If
        Catch ex As Exception
            MessageBox.Show(ex.Message, "Query Error", _
                MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        Finally
            If m_Connection.State = ConnectionState.Open Then m_Connection.Close()
        End Try
    End Sub

    ' Verify the user name and password safely.
    Private Sub btnSafe_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSafe.Click
        ' Compose the query.
        Dim user_name As String = txtUserName.Text.Replace("'", "''")
        Dim password As String = txtPassword.Text.Replace("'", "''")
        Dim query As String = _
            "SELECT COUNT(*) FROM Users " & _
            "WHERE UserName = '" & user_name & "'" & _
            "  AND Password = '" & password & "'"
        Debug.WriteLine(query)

        ' Execute the query.
        Try
            m_Connection.Open()
            Dim cmd As New OleDbCommand(query, m_Connection)
            Dim result As Integer = CInt(cmd.ExecuteScalar())
            m_Connection.Close()

            If result > 0 Then
                MessageBox.Show("User verified")
            Else
                MessageBox.Show("Invalid user")
            End If
        Catch ex As Exception
            MessageBox.Show(ex.Message, "Query Error", _
                MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        Finally
            If m_Connection.State = ConnectionState.Open Then m_Connection.Close()
        End Try
    End Sub
End Class
