Imports System.ComponentModel
Imports System.Drawing
Imports System.Windows.Forms

<ToolboxBitmap(GetType(ExtraTagProvider), "tbxExtraTagProvider")> _
<ProvideProperty("ExtraTag", GetType(Control))> _
Public Class ExtraTagProvider
    Implements IExtenderProvider

    ' Hold controls' extra tags.
    Private m_ExtraTags As New Generic.Dictionary(Of Control, String)

    ' We extend Labels and TextBoxes.
    Public Function CanExtend(ByVal extendee As Object) As Boolean Implements System.ComponentModel.IExtenderProvider.CanExtend
        Return (TypeOf (extendee) Is Label) OrElse (TypeOf (extendee) Is TextBox)
    End Function

    ' Return a control's ExtraTag value.
    Public Function GetExtraTag(ByVal client_control As Control) As String
        If m_ExtraTags.ContainsKey(client_control) Then
            Return m_ExtraTags.Item(client_control)
        Else
            Return ""
        End If
    End Function

    ' Set a TextBox's ExtraTag value.
    Public Sub SetExtraTag(ByVal client_control As Control, ByVal extra_tag As String)
        If extra_tag Is Nothing Then extra_tag = ""
        If extra_tag.Length = 0 Then
            ' Remove it.
            If m_ExtraTags.ContainsKey(client_control) Then
                m_ExtraTags.Remove(client_control)
            End If
        Else
            ' Add it.
            m_ExtraTags.Item(client_control) = extra_tag
        End If
    End Sub
End Class
