Imports System.ComponentModel

Public Class ContactViewer
    Private WithEvents m_Contact As Contact = New Contact
    <NotifyParentProperty(True)> _
    <RefreshProperties(RefreshProperties.Repaint)> _
    Public Property Contact() As Contact
        Get
            Return m_Contact
        End Get
        Set(ByVal value As Contact)
            m_Contact = value

            lblFirstName.Text = m_Contact.FirstName
            lblLastName.Text = m_Contact.LastName
            lblPhone.Text = m_Contact.Phone
        End Set
    End Property

    ' Data has changed. Display the new values.
    Private Sub m_Contact_DataChanged() Handles m_Contact.DataChanged
        lblFirstName.Text = m_Contact.FirstName
        lblLastName.Text = m_Contact.LastName
        lblPhone.Text = m_Contact.Phone
    End Sub

    Private WithEvents m_Address As Address = New Address
    Public Property Address() As Address
        Get
            Return m_Address
        End Get
        Set(ByVal value As Address)
            m_Address = value

            lblStreet.Text = m_Address.Street
            lblCity.Text = m_Address.City
            lblState.Text = m_Address.State
            lblZip.Text = m_Address.Zip
        End Set
    End Property

    ' Data has changed. Display the new values.
    Private Sub m_Address_DataChanged() Handles m_Address.DataChanged
        lblStreet.Text = m_Address.Street
        lblCity.Text = m_Address.City
        lblState.Text = m_Address.State
        lblZip.Text = m_Address.Zip
    End Sub

    ' Display the initial information.
    Private Sub ContactViewer_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        m_Address.Street = "1066 Hastings Wy"
        m_Address.City = "Archer"
        m_Address.State = "MT"
        m_Address.Zip = "48937"

        lblFirstName.Text = m_Contact.FirstName
        lblLastName.Text = m_Contact.LastName
        lblPhone.Text = m_Contact.Phone

        lblStreet.Text = m_Address.Street
        lblCity.Text = m_Address.City
        lblState.Text = m_Address.State
        lblZip.Text = m_Address.Zip
    End Sub
End Class
