Imports System.Drawing.Design
Imports System.ComponentModel

<ToolboxBitmap(GetType(EllipseControl), "tbxEllipse")> _
Public Class EllipseControl
    Inherits Control

    Public Enum ColorIndexes
        Red
        Orange
        Yellow
        Green
        Blue
        Ingido
        Violet
        Black
        White
    End Enum
    Public Const NumColorIndexes As Integer = 9

    Private m_FillColor As ColorIndexes = ColorIndexes.White
    <EditorAttribute(GetType(ColorIndexEditor), GetType(UITypeEditor))> _
    Public Property FillColor() As ColorIndexes
        Get
            Return m_FillColor
        End Get
        Set(ByVal value As ColorIndexes)
            m_FillColor = value
            Me.Invalidate()
        End Set
    End Property

    Private m_LineColor As ColorIndexes = ColorIndexes.White
    <EditorAttribute(GetType(ColorIndexEditor), GetType(UITypeEditor))> _
    Public Property LineColor() As ColorIndexes
        Get
            Return m_LineColor
        End Get
        Set(ByVal value As ColorIndexes)
            m_LineColor = value
            Me.Invalidate()
        End Set
    End Property

    Private m_LineWidth As Integer = 1
    <EditorAttribute(GetType(LineWidthEditor), GetType(UITypeEditor))> _
    Public Property LineWidth() As Integer
        Get
            Return m_LineWidth
        End Get
        Set(ByVal value As Integer)
            If value < 1 Then value = 1
            If value > 10 Then value = 10
            m_LineWidth = value
            Me.Invalidate()
        End Set
    End Property

    ' Draw the ellipse.
    Private Sub EllipseControl_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles Me.Paint
        e.Graphics.Clear(Me.BackColor)

        Dim rect As New Rectangle(CInt(m_LineWidth / 2), CInt(m_LineWidth / 2), _
            Me.ClientRectangle.Width - m_LineWidth - 1, _
            Me.ClientRectangle.Height - m_LineWidth - 1)

        Dim colors() As Color = {Color.Red, Color.Orange, Color.Yellow, Color.Green, Color.Blue, Color.Indigo, Color.Violet, Color.Black, Color.White}
        Dim fill_color As Color = colors(m_FillColor)

        Using bg_brush As New SolidBrush(fill_color)
            e.Graphics.FillEllipse(bg_brush, rect)
        End Using

        Dim fore_color As Color = colors(m_LineColor)
        Using fg_pen As New Pen(fore_color, m_LineWidth)
            e.Graphics.DrawEllipse(fg_pen, rect)
        End Using
    End Sub
End Class
