Imports System.Drawing.Design

Public Class LedControlEditor
    Inherits System.Drawing.Design.UITypeEditor

    ' Indicates that this editor displays a dropdown.
    Public Overloads Overrides Function GetEditStyle(ByVal context As System.ComponentModel.ITypeDescriptorContext) As System.Drawing.Design.UITypeEditorEditStyle
        Return UITypeEditorEditStyle.DropDown
    End Function

    ' Edit a LedControl's value.
    Public Overloads Overrides Function EditValue(ByVal context As System.ComponentModel.ITypeDescriptorContext, ByVal provider As System.IServiceProvider, ByVal value As Object) As Object
        ' Get an IWindowsFormsEditorService.
        Dim editor_service As IWindowsFormsEditorService = _
            CType(provider.GetService(GetType(IWindowsFormsEditorService)), _
                IWindowsFormsEditorService)

        ' If we failed to get the editor service, return the value.
        If editor_service Is Nothing Then Return value

        ' Convert the generic value into an array of Boolean.
        Dim lines_on() As Boolean = DirectCast(value, Boolean())

        ' Make the editing control.
        Dim editor_control As New LedControlEditorDropdown(lines_on, editor_service)
        
        ' Display the editing control.
        editor_service.DropDownControl(editor_control)

        ' Save the new results.
        Return editor_control.LinesOn
    End Function
End Class
