Imports System.ComponentModel

<ToolboxItem(False)> _
Public Class ColorIndexListBox
    Inherits ListBox

    ' The editor service displaying us.
    Private m_EditorService As IWindowsFormsEditorService

    ' A margin around the image in the list box.
    Private Const ITEM_MARGIN As Integer = 2

    Public Sub New(ByVal color_index As ScribbleControl.LineColors, ByVal editor_service As IWindowsFormsEditorService)
        MyBase.New()
        m_EditorService = editor_service

        ' Give the list some items.
        For i As Integer = 0 To ScribbleControl.NumLineColors - 1
            Me.Items.Add(i)
        Next i
        Me.SelectedIndex = color_index
        Me.DrawMode = Windows.Forms.DrawMode.OwnerDrawFixed
        Me.ItemHeight = 16 + 2 * ITEM_MARGIN
    End Sub

    ' Close the dropdown.
    Private Sub ColorIndexEditorDropdown_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Click
        If m_EditorService IsNot Nothing Then m_EditorService.CloseDropDown()
    End Sub

    ' Draw a menu item.
    Private Sub ColorIndexEditorDropdown_DrawItem(ByVal sender As Object, ByVal e As System.Windows.Forms.DrawItemEventArgs) Handles Me.DrawItem
        ' Clear the background background.
        e.DrawBackground()

        ' Decide where to draw.
        Dim rect As New Rectangle( _
            e.Bounds.X + ITEM_MARGIN, _
            e.Bounds.Y + ITEM_MARGIN, _
            e.Bounds.Width - 2 * ITEM_MARGIN, _
            e.Bounds.Height - 2 * ITEM_MARGIN)

        ' Draw the appropriate color.
        Dim colors() As Color = {Color.Red, Color.Orange, Color.Yellow, Color.Green, Color.Blue, Color.Indigo, Color.Violet, Color.Black, Color.White}
        Dim fill_color As Color = colors(e.Index)
        Using fill_brush As New SolidBrush(fill_color)
            e.Graphics.FillRectangle(fill_brush, rect)
        End Using

        ' Draw the focus rectangle if appropriate.
        If e.State = DrawItemState.Selected Then e.DrawFocusRectangle()
    End Sub
End Class
