' A group of polylines used to draw the scribble picture.
<Serializable()> _
Public Class PolyPolyline
    Public Polylines() As Polyline = {}

    ' Clear all polylines.
    Public Sub Clear()
        Polylines = New Polyline() {}
    End Sub

    ' Start a new polyline.
    Public Sub AddPolyline()
        ReDim Preserve Polylines(0 To Polylines.Length)
        Polylines(Polylines.Length - 1) = New Polyline
    End Sub

    ' Add a new point to the last Polyline.
    ' Don't add duplicates. Return True if we add a point.
    Public Function AddPoint(ByVal x As Integer, ByVal y As Integer) As Boolean
        If Polylines.Length < 1 Then Throw New ArgumentException("Cannot add point until you start a Polyline")

        Return Polylines(Polylines.Length - 1).AddPoint(x, y)
    End Function

    ' The program is done adding points to this polyline.
    ' If the polyline has fewer than 2 points, remove it.
    Public Sub EndPolyline()
        If Polylines(Polylines.Length - 1).IsEmpty() Then
            ReDim Preserve Polylines(Polylines.Length - 2)
        End If
    End Sub

    ' Draw.
    Public Sub Draw(ByVal gr As Graphics, ByVal the_pen As Pen)
        For i As Integer = 0 To Polylines.Length - 1
            Polylines(i).Draw(gr, the_pen)
        Next i
    End Sub

    ' Make a deep copy.
    Public Function Clone() As PolyPolyline
        ' Clone the outer level of the Polylines array.
        Dim ppline As PolyPolyline = DirectCast(Me.MemberwiseClone(), PolyPolyline)

        ' Clone the polylines.
        For i As Integer = 0 To Polylines.Length - 1
            ppline.Polylines(i) = DirectCast(Me.Polylines(i).Clone(), Polyline)
        Next i

        Return ppline
    End Function

    ' Return the PolyPolyline's bounds.
    Public Function Bounds() As Rectangle
        Dim rect As Rectangle = Polylines(0).Bounds()
        For i As Integer = 1 To Polylines.Length - 1
            rect = Rectangle.Union(rect, Polylines(i).Bounds())
        Next i
        Return rect
    End Function
End Class
