Imports System.Xml.Serialization

<Serializable()> _
Public Class Person
    Private m_FirstName As String = ""
    <XmlAttribute("GivenName")> _
    Public Property FirstName() As String
        Get
            Return m_FirstName
        End Get
        Set(ByVal value As String)
            m_FirstName = value
        End Set
    End Property

    Private m_LastName As String = ""
    <XmlText(GetType(String))> _
    Public Property LastName() As String
        Get
            Return m_LastName
        End Get
        Set(ByVal value As String)
            m_LastName = value
        End Set
    End Property

    Public Enum PersonTypes
        <XmlEnum("Unknown")> None
        <XmlEnum("Customer")> Cust
        <XmlEnum("Manager")> Mgr
        <XmlEnum("Employee")> Emp
    End Enum
    Private m_PersonType As PersonTypes = PersonTypes.Cust
    <XmlElement("TypeOfPerson")> _
    Public Property PersonType() As PersonTypes
        Get
            Return m_PersonType
        End Get
        Set(ByVal value As PersonTypes)
            m_PersonType = value
        End Set
    End Property

    Private m_OnlineStatus As String = ""
    <XmlIgnore()> _
    Public Property OnlineStatus() As String
        Get
            Return m_OnlineStatus
        End Get
        Set(ByVal value As String)
            m_OnlineStatus = value
        End Set
    End Property

    Private m_Address As Address = Nothing
    Public Property Address() As Address
        Get
            Return m_Address
        End Get
        Set(ByVal value As Address)
            m_Address = value
        End Set
    End Property

    Private m_Letters() As String = {}
    <XmlArray("TheLetters")> _
    <XmlArrayItem("ALetter")> _
    Public Property Letters() As String()
        Get
            Return m_Letters
        End Get
        Set(ByVal value() As String)
            m_Letters = value
        End Set
    End Property

    Private m_Things() As Object = Nothing
    <XmlElement(GetType(Thing1))> _
    <XmlElement(GetType(Thing2))> _
    Public Property Things() As Object()
        Get
            Return m_Things
        End Get
        Set(ByVal value() As Object)
            m_Things = value
        End Set
    End Property

    Public Sub New()
    End Sub

    Public Sub New(ByVal new_FirstName As String, ByVal new_LastName As String, ByVal new_OnlineStatus As String, ByVal new_Address As Address, ByVal new_Letters() As String)
        FirstName = new_FirstName
        LastName = new_LastName
        OnlineStatus = new_OnlineStatus
        Address = new_Address
        Letters = new_Letters
    End Sub
End Class

<Serializable()> _
Public Class Address
    <XmlAttribute()> _
    Public Street As String

    <XmlAttribute("Town")> _
    Public City As String

    <XmlText()> _
    Public State As String

    Public Zip As String

    Public Sub New()
    End Sub

    Public Sub New(ByVal new_Street As String, ByVal new_City As String, ByVal new_State As String, ByVal new_Zip As String)
        Street = new_Street
        City = new_City
        State = new_State
        Zip = new_Zip
    End Sub
End Class

Public Class Thing1
    Public Value As Integer = 111
End Class

Public Class Thing2
    Public Thing2Value As Integer = 222
End Class