Public Class Form1
    ' Add a HelpRequested event handler to every control.
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        For Each ctl As Control In Me.Controls
            AddHandler ctl.HelpRequested, AddressOf Control_HelpRequested
        Next ctl
    End Sub

    ' Display help for the clicked control.
    Private Sub Control_HelpRequested(ByVal sender As Object, ByVal hlpevent As System.Windows.Forms.HelpEventArgs)
        ' Get the control.
        Dim ctl As Control = DirectCast(sender, Control)

        ' Display the control's Tag property.
        Dim txt As String = DirectCast(ctl.Tag, String)
        If (txt Is Nothing) OrElse (txt.Length = 0) Then
            MessageBox.Show( _
                "Sorry, there's no help for control " & ctl.Name, _
                "Help", MessageBoxButtons.OK, MessageBoxIcon.Information)
        Else
            MessageBox.Show( _
                txt, _
                "Help", MessageBoxButtons.OK, MessageBoxIcon.Information)
        End If
    End Sub
End Class
