Public Class Customer
    Inherits Person

    ''' <summary>
    ''' The private variable that holds the Address value.
    ''' </summary>
    ''' <remarks>Use the property procedures to get and set this value.</remarks>
    ''' <scope>Private</scope>
    Private m_Address As String

    ''' <summary>
    ''' The Customer's mailing address.
    ''' </summary>
    ''' <value>The Customer's address.</value>
    ''' <returns>A customer's address.</returns>
    ''' <remarks>Used in mailing addresses.</remarks>
    ''' <scope>Public</scope>
    Public Property Address() As String
        Get
            Return m_Address
        End Get
        Set(ByVal value As String)
            m_Address = value
        End Set
    End Property

    Private m_City As String
    Public Property City() As String
        Get
            Return m_City
        End Get
        Set(ByVal value As String)
            m_City = value
        End Set
    End Property
End Class
