Imports System.Math

Public Class Form1
    Private m_Drawing As Boolean = False
    Private m_LastPoint As Point = Nothing

#Region "Event Handlers"
    ' Start drawing.
    Private Sub Form1_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Me.MouseDown
        DoMouseDown(e.X, e.Y)
    End Sub

    ' Continue drawing.
    Private Sub Form1_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Me.MouseMove
        DoMouseMove(e.X, e.Y)
    End Sub

    ' Stop drawing.
    Private Sub Form1_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Me.MouseUp
        DoMouseUp()
    End Sub
#End Region ' Event Handlers

#Region "Do Routines"
    ' Start drawing.
    Private Sub DoMouseDown(ByVal x As Integer, ByVal y As Integer)
        m_Drawing = True
        m_LastPoint = New Point(x, y)
        Dim gr As Graphics = Me.CreateGraphics()
        gr.Clear(Me.BackColor)
    End Sub

    ' Continue drawing.
    Private Sub DoMouseMove(ByVal x As Integer, ByVal y As Integer)
        If Not m_Drawing Then Exit Sub
        Dim gr As Graphics = Me.CreateGraphics()
        gr.DrawLine(Pens.Blue, m_LastPoint, New Point(x, y))
        m_LastPoint = New Point(x, y)
    End Sub

    ' Stop drawing.
    Private Sub DoMouseUp()
        m_Drawing = False
    End Sub
#End Region ' Do Routines

#Region "GUI Testing"
    ' Simulate manual drawing by using mouse_event.
    Private Sub btnSimulatedDraw_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSimulatedDraw.Click
        Dim cx As Integer = Me.ClientSize.Width \ 2
        Dim cy As Integer = Me.ClientSize.Height \ 2
        Dim radius As Integer = Math.Min(Me.ClientSize.Width, Me.ClientSize.Height) \ 3

        ' MouseDown.
        DoMouseDown( _
            CInt(cx + radius * Cos(0)), _
            CInt(cy + radius * Sin(0)))

        ' Move the mouse around in a randomized circle.
        Dim rnd As New Random
        For angle As Double = PI / 10 To 6 * PI Step PI / 10
            DoMouseMove( _
                CInt(cx + radius * Cos(angle) + rnd.Next(-20, 20)), _
                CInt(cy + radius * Sin(angle) + rnd.Next(-20, 20)))
        Next angle

        ' Connect back to the first point.
        DoMouseMove( _
            CInt(cx + radius * Cos(0)), _
            CInt(cy + radius * Sin(0)))

        ' MouseUp.
        DoMouseUp()
    End Sub
#End Region ' GUI Testing
End Class
