Imports System.ComponentModel
Imports System.Threading
Imports System.Math
Imports System.Diagnostics

Public Class Form1
    Private m_Wid As Integer
    Private m_Hgt As Integer

    ' The graph's image.
    Private m_Bitmap As Bitmap
    Private m_LastY As Integer

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' Get the PictureBoxes' dimensions.
        m_Wid = picGraph.ClientSize.Width
        m_Hgt = picGraph.ClientSize.Height

        ' Make the bitmaps.
        m_Bitmap = New Bitmap(m_Wid, m_Hgt)
        Using gr As Graphics = Graphics.FromImage(m_Bitmap)
            gr.Clear(Color.White)
        End Using
        picGraph.Image = m_Bitmap

        ' Start the background worker.
        m_LastY = m_Hgt
        bgwCpuGraph.RunWorkerAsync()
    End Sub

    ' Plot a data point.
    Private Delegate Sub PlotPointDelegate(ByVal Y As Integer)
    Private m_PlotPointDelegate As PlotPointDelegate = AddressOf Me.PlotPoint
    Private Sub PlotPoint(ByVal Y As Integer)
        ' Scale to fit the PictureBox.
        Y = CInt(m_Hgt * (1 - Y / 100))

        ' Scoot the image over to the left.
        Dim bm As New Bitmap(m_Wid, m_Hgt)
        Using gr As Graphics = Graphics.FromImage(bm)
            gr.DrawImage(m_Bitmap, -1, 0)

            ' Clear the right edge.
            gr.DrawLine(Pens.White, m_Wid - 1, 0, m_Wid - 1, m_Hgt)

            ' Draw the new point.
            gr.DrawLine(Pens.Blue, m_Wid - 2, m_LastY, m_Wid - 1, Y)
        End Using

        ' Save the new Y value.
        m_LastY = Y

        ' Refresh the graph.
        m_Bitmap = bm
        picGraph.Image = bm
    End Sub

    ' Draw graph 0.
    Private Sub bgwGraph0_DoWork(ByVal sender As System.Object, ByVal e As System.ComponentModel.DoWorkEventArgs) Handles bgwCpuGraph.DoWork
        ' Work at reduced priority.
        Thread.CurrentThread.Priority = ThreadPriority.BelowNormal

        Dim performance_counter As New _
            PerformanceCounter( _
                "Processor", "% Processor Time", "_Total")

        Static X As Integer = 0
        Do
            ' Calculate the next point.
            X += 1

            ' Report the point to the UI thread.
            Dim value As Integer = CInt(performance_counter.NextValue())
            Me.Invoke(Me.m_PlotPointDelegate, value)

            ' Pause a while.
            Thread.Sleep(100)

            ' See if we should cancel.
            If Me.bgwCpuGraph.CancellationPending Then Exit Do
        Loop
    End Sub
End Class
