Imports System.Reflection
Imports System.Collections.Generic
Imports System.Drawing

Public Class Form1
    Private Const XMIN As Integer = 10
    Private Const SAMPLE_WID As Integer = 120
    Private Const SAMPLE_HGT As Integer = 30
    Private Const X_MARGIN As Integer = 10
    Private Const Y_MARGIN As Integer = 20

    Private m_Colors As New List(Of Color)
    Private m_ColorNames As New List(Of String)

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' Enumerate the SystemColors styles.
        Dim system_colors_type As Type = GetType(SystemColors)
        Dim property_infos() As PropertyInfo = system_colors_type.GetProperties()
        For Each property_info As PropertyInfo In property_infos
            ' Get this color.
            Dim color_obj As Object = property_info.GetValue(Nothing, Nothing)
            Dim system_color As Color = DirectCast(color_obj, Color)

            ' Save the color and name.
            m_Colors.Add(system_color)
            m_ColorNames.Add(property_info.Name)
        Next property_info

        ' Prepare for Paint events.
        Me.SetStyle( _
            ControlStyles.AllPaintingInWmPaint Or _
            ControlStyles.ResizeRedraw Or _
            ControlStyles.OptimizedDoubleBuffer, _
            True)
        Me.UpdateStyles()

        Me.ClientSize = New Size( _
            2 * XMIN + 6 * SAMPLE_WID + 5 * X_MARGIN, _
            3 * XMIN + 6 * SAMPLE_HGT + 5 * Y_MARGIN)
    End Sub

    ' Display color samples.
    Private Sub Form1_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles Me.Paint
        e.Graphics.Clear(Me.BackColor)
        Dim x As Integer = XMIN
        Dim y As Integer = XMIN

        For i As Integer = 0 To m_Colors.Count - 1
            DrawSample(e.Graphics, x, y, m_Colors(i), m_ColorNames(i))
        Next i
    End Sub

    ' Draw the sample and move (x, y) to a new position.
    Private Sub DrawSample(ByVal gr As Graphics, ByRef x As Integer, ByRef y As Integer, ByVal the_color As Color, ByVal color_name As String)
        ' Draw the sample.
        Using br As New SolidBrush(the_color)
            gr.FillRectangle(br, x, y, SAMPLE_WID, SAMPLE_HGT)
        End Using
        gr.DrawRectangle(Pens.Red, x, y, SAMPLE_WID, SAMPLE_HGT)

        ' Draw the color's name.
        Dim string_format As New StringFormat()
        string_format.Alignment = StringAlignment.Center
        string_format.LineAlignment = StringAlignment.Near
        gr.DrawString(color_name, Me.Font, Brushes.Blue, _
            x + SAMPLE_WID \ 2, y + SAMPLE_HGT, string_format)

        ' Update x and y.
        x += SAMPLE_WID + X_MARGIN
        If x + SAMPLE_WID > Me.ClientSize.Width Then
            x = XMIN
            y += SAMPLE_HGT + Y_MARGIN
        End If
    End Sub
End Class
