Imports System.Reflection
Imports System.Collections.Generic
Imports System.Drawing.Drawing2D

Public Class Form1
    Private Const XMIN As Integer = 10
    Private Const SAMPLE_WID As Integer = 120
    Private Const SAMPLE_HGT As Integer = 30
    Private Const X_MARGIN As Integer = 10
    Private Const Y_MARGIN As Integer = 20

    ' Prepare for Paint events.
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.SetStyle( _
            ControlStyles.AllPaintingInWmPaint Or _
            ControlStyles.ResizeRedraw Or _
            ControlStyles.OptimizedDoubleBuffer, _
            True)
        Me.UpdateStyles()

        Me.ClientSize = New Size( _
            2 * XMIN + 6 * SAMPLE_WID + 5 * X_MARGIN, _
            3 * XMIN + 6 * SAMPLE_HGT + 5 * Y_MARGIN)
    End Sub

    ' Display pen samples.
    Private Sub Form1_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles Me.Paint
        e.Graphics.Clear(Me.BackColor)
        Dim x As Integer = XMIN
        Dim y As Integer = XMIN

        ' Enumerate the pen styles.
        Dim system_pens_type As Type = GetType(SystemPens)
        Dim property_infos() As PropertyInfo = system_pens_type.GetProperties()
        For Each property_info As PropertyInfo In property_infos
            ' Get this pen.
            Dim pen_obj As Object = _
                system_pens_type.InvokeMember( _
                    property_info.Name, BindingFlags.GetProperty, _
                    Nothing, Nothing, Nothing)
            Dim the_pen As Pen = DirectCast(pen_obj, Pen)
            DrawSample(e.Graphics, x, y, the_pen, property_info.Name)
        Next property_info
    End Sub

    ' Draw the sample and move (x, y) to a new position.
    Private Sub DrawSample(ByVal gr As Graphics, ByRef x As Integer, ByRef y As Integer, ByVal the_pen As Pen, ByVal pen_name As String)
        ' Draw the sample.
        gr.DrawRectangle(the_pen, x, y, SAMPLE_WID, SAMPLE_HGT)

        ' Draw the pen's name.
        Dim string_format As New StringFormat()
        string_format.Alignment = StringAlignment.Center
        string_format.LineAlignment = StringAlignment.Near
        gr.DrawString(pen_name, Me.Font, Brushes.Blue, _
            x + SAMPLE_WID \ 2, y + SAMPLE_HGT, string_format)

        ' Update x and y.
        x += SAMPLE_WID + X_MARGIN
        If x + SAMPLE_WID > Me.ClientSize.Width Then
            x = XMIN
            y += SAMPLE_HGT + Y_MARGIN
        End If
    End Sub
End Class
