Imports System.Collections.Generic
Imports System.IO
Imports System.Reflection

Public Class Form1
     ' Load available tools.
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Try
            ' Find the tools library.
            Dim file_info As New FileInfo(Application.StartupPath & _
                "..\..\..\..\ReflectionTools\bin\Debug\ReflectionTools.dll")

            ' Get the tool library's assembly information.
            Dim tool_assembly As [Assembly] = _
                [Assembly].LoadFrom(file_info.FullName)
            Dim assembly_namespace As String = tool_assembly.GetName().Name

            ' Make arguments for the InstallTools method.
            Dim args() As Object = {mnuTools, rchDocument}

            ' Loop through available classes looking
            ' for those that implement IToolInstaller.
            For Each class_type As Type In tool_assembly.GetTypes()
                ' See if it implements IToolInstaller.
                If class_type.GetInterface("IToolInstaller") IsNot Nothing Then
                    ' Make an instance of the class.
                    Dim class_instance As Object = class_type.InvokeMember( _
                        Nothing, BindingFlags.CreateInstance, Nothing, Nothing, Nothing)

                    ' Invoke the InstallTools method.
                    class_type.InvokeMember( _
                        "InstallTools", BindingFlags.InvokeMethod, _
                        Nothing, class_instance, args)
                End If
            Next class_type
        Catch ex As Exception
            MessageBox.Show( _
                "Error loading tools" & vbCrLf & ex.Message, _
                "Tool Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
        End Try
    End Sub

    ' Close the application.
    Private Sub mnuFileExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles mnuFileExit.Click
        Me.Close()
    End Sub
End Class
