Public Class Form1
    Public Class Cell
        Public MyForm As Form1

        Public Values(100) As Integer
        Public NextCell As Cell

        Public Sub New(ByVal new_MyForm As Form1)
            MyForm = new_MyForm
        End Sub

        Protected Overrides Sub Finalize()
            If MyForm.GCRunning Then Exit Sub
            Debug.WriteLine("Garbage collecting " & MyForm.NumGCs & "...")
            MyForm.GCRunning = True
            MyForm.NumGCs += 1
        End Sub
    End Class

    Public GCRunning As Boolean = False
    Public NumGCs As Integer = 0

    Private Sub btnRun_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRun.Click
        Dim start_time As Date = Now

        NumGCs = 0
        Dim num_trials As Long = Long.Parse(txtNumTrials.Text)
        For i As Long = 1 To num_trials
            ' Allocate a bunch of objects.
            Dim top As New Cell(Me)
            top.NextCell = Nothing

            For j As Integer = 1 To 99
                Dim new_cell As New Cell(Me)
                new_cell.NextCell = top
                top = new_cell
            Next j

            ' Free the objects.
            top = Nothing
            GCRunning = False
        Next i

        ' Force a final GC.
        GC.Collect()
        Debug.WriteLine("Done")

        Dim stop_time As Date = Now
        Dim elapsed_time As TimeSpan = stop_time.Subtract(start_time)
        Debug.WriteLine("Elapsed time: " & elapsed_time.TotalSeconds.ToString("0.00"))
    End Sub

    Private Sub btnPreallocateRun_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPreallocateRun.Click
        Dim start_time As Date = Now

        NumGCs = 0

        ' Preallocate some Cell objects.
        Dim available(100) As Cell
        available(available.Length - 1) = New Cell(Me)
        available(available.Length - 1).NextCell = Nothing
        For i As Integer = available.Length - 2 To 0 Step -1
            available(i) = New Cell(Me)
            available(i).NextCell = available(i + 1)
        Next i
        Dim top_available As Cell = available(0)

        ' Perform the trials.
        Dim num_trials As Long = Long.Parse(txtNumTrials.Text)
        For i As Long = 1 To num_trials
            ' Allocate a bunch of objects.
            Dim top As New Cell(Me)
            top.NextCell = Nothing

            For j As Integer = 1 To 99
                Dim new_cell As Cell = top_available
                top_available = top_available.NextCell

                new_cell.NextCell = top
                top = new_cell
            Next j

            ' Free the objects.
            Dim last_cell As Cell = top_available
            Do While last_cell.NextCell IsNot Nothing
                last_cell = last_cell.NextCell
            Loop
            last_cell.NextCell = top
            top = Nothing
            GCRunning = False
        Next i

        ' Deallocate the objects.
        top_available = Nothing
        Erase available

        ' Force a final GC.
        GC.Collect()

        Dim stop_time As Date = Now
        Dim elapsed_time As TimeSpan = stop_time.Subtract(start_time)
        Debug.WriteLine("Elapsed time: " & elapsed_time.TotalSeconds.ToString("0.00"))
    End Sub
End Class
